<script setup lang="ts">
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import { useReceipetStore } from '@/stores/receipt'
import type { Receipt } from '@/types/Receipt'
import type { User } from '@/types/User'
import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import ReceiptDialog from './POS/ReceiptDialog.vue'

const receiptStore = useReceipetStore()

let editedIndex = -1
const editedReceipt = ref<Receipt>(JSON.parse(JSON.stringify(receiptStore.receipt)))
const receipts = ref<Receipt[]>([])
receipts.value = receiptStore.receipts
const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Created Date',
    key: 'createdDate',
    width: '300px'
  },
  {
    title: 'Total Before',
    key: 'totalBefore'
  },
  {
    title: 'total',
    key: 'total'
  },
  {
    title: 'Receiced Amount',
    key: 'receicedAmount'
  },
  {
    title: 'Change',
    key: 'change'
  },
  {
    title: 'Member Discount',
    key: 'memberDiscount'
  },
  {
    title: 'Payment Type',
    key: 'paymentType'
  },
  {
    title: 'User ID',
    key: 'userId'
  },
  {
    title: 'User',
    key: 'user',
    value: (item: any | Receipt) => item.user.fullname,
    width: '150px'
  },
  {
    title: 'Member ID',
    key: 'memberID'
  },
  {
    title: 'Reciept Item',
    key: 'recieptItem',
    width: '300px',
    value: (item: any | Receipt) => {
      if (item && item.recieptItem) {
        return item.recieptItem
          .map((product: any) => {
            return `
              Name: ${product.name}
              Price: ${product.price}
              Unit: ${product.unit}
          `
          })
          .join('////////')
      }

      return ''
    }
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedReceipt.value = Object.assign({}, receiptStore.receipt)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(receipts.value[editedIndex], editedReceipt.value)
  }
  closeDialog()
}

function editItem(item: Receipt) {
  editedIndex = receipts.value.indexOf(item)
  editedReceipt.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Receipt) {
  editedIndex = receipts.value.indexOf(item)
  editedReceipt.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  receipts.value.splice(editedIndex, 1)
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedReceipt.value = Object.assign({}, receiptStore.receipt)
  })
  editedIndex = -1
}
</script>

<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->

  <div>
    <v-data-table :headers="headers" :items="receipts">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #212121; color: white">
          <v-toolbar-title>Receipt History</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="700">
            <v-card>
              <v-card-title>
                <span class="text-h5">Receipt History</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit()">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedReceipt.createdDate"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Created Date"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.totalBefore"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Total Before"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.total"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Total"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.receicedAmount"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Receiced Amount"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.change"
                          :readonly="loading"
                          class="mb-2"
                          clearable
                          label="Change"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.memberDiscount"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Member Discount"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedReceipt.paymentType"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Payment Type"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please fill data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
  <ReceiptDialog></ReceiptDialog>
</template>

<style scoped></style>
